#!/bin/bash

# Script to guarantee correct execution of processes on cluster.
# All RaLaNS_Launcher processes must be enqueued before RaLaNS_extEdges starts.

# enq is a boolean value
enq=0

# start index
start=0

# number of receivers
recvs=${1}

# ID of this job
ID=${PBS_JOBID//[a-z,.,-]/}
# ID of array job
ARRAY=$((${ID}+1))

# as long as not every job of array is in queue
while [ ${enq} -ne 1 ]; do
  bool=0

  # for all jobs
  for i in `seq ${start} ${recvs}`;
  do
    # current job ARRAY[i]
    arrayid=${ARRAY}"["${i}"]"
    qstat=$(qstat ${arrayid});
    
    # if the job is in queue, then bool=true
    if [[ ${qstat} == *"H default"* ]]; then
      # echo ${arrayid} "in queue"
      let bool=1
    else
      # echo ${arrayid} "not in queue"
      let bool=0
      let start=${i}
      break
    fi
  done

  # if job represented by last id of array is in queue we expect all jobs in queue
  if [ ${bool} -eq 1 ]; then
    let enq=1
  fi
done
